#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <locale.h>
#include <wchar.h> 
#include <sys/stat.h>
#include <fcntl.h>

int debug_level = 0;

int main( int argc, char **argv, char **envp ) {
   char sopt[] = "l:v", new_loc[ 40 ] = "";
   int c, i, n; 
   while( -1 != ( c = getopt( argc, argv, sopt ) ) )
      switch( c ) {
         case 'l':
            strcpy( new_loc, optarg );
            break;
         case 'v':
            debug_level++;
            break;
         default :
            fprintf( stdout, "допустимые опции: %s\n", sopt );
            return( EXIT_FAILURE );
      }
   i = 0;  
   if( debug_level > 1 ) { 
      fprintf( stdout, "размер wchar_t = %d, размер wint_t = %d\n",
                       sizeof( wchar_t ), sizeof( wint_t ) );
      while( envp[ i ] != NULL ) {
         if( strstr( envp[ i++ ], "LC_" ) != NULL ) {
            fprintf( stdout, "%s\n", envp[ i ] );
            n++; 
         }
      };
      if( 0 == n ) fprintf( stdout, "LC_CTYPE=\n" );
   }
   char *loc = setlocale( LC_ALL, new_loc ); // по умолчанию ("") - из $LANG
//   char *loc = setlocale( LC_CTYPE, "ru_RU.utf8" );  
   if( NULL == loc ) perror( "locale error" );
   else fprintf( stdout, "локализация: %s\n", loc );
#define LENGTH 200
   char buf[ LENGTH ];
   wchar_t wbuf[ LENGTH * 4 ];
   mbstate_t state;    // mbstate_t state = { 0 };
   while( 1 ) {
      fprintf( stdout, "строка (или @файл): " );
      fflush( stdout );
      fgets( buf, sizeof( buf ) - 1, stdin );
      buf[ strlen( buf ) - 1 ] = '\0';;
//fprintf( stdout, "%s\n", buf );
      if( '@' == buf[ 0 ] ) {
         int fd = open( &buf[ 1 ], O_RDONLY );
         if( fd < 0 ) { perror( "ошибочный файл" ); continue; }
         n = read( fd, buf, LENGTH - 1 );
         if( n < 0 ) perror( "ошибка чтения" );
         close( fd );
         if( n < 0 ) continue;
         if( buf[ n - 1 ] != '\n' ) { buf[ n - 1 ] != '\n'; n++; }
         buf[ n - 1 ] = '\0';          
         if( debug_level > 0 ) fprintf( stdout, "считано из файла: %s\n", buf );
      }
      memset( &state, 0, sizeof( mbstate_t ) );
      const char *pb = (char*)&buf[ 0 ];
      n = mbsrtowcs( wbuf, &pb, LENGTH - 1, &state );
      if( n < 0 ) perror( "ошибка преобразования в wchar_t" );
      else fprintf( stdout, "преобразовано: %d байт в %d символов\n", strlen( buf ), n );
      fprintf( stdout, "printf: %ls\n", wbuf );
   }
   return( EXIT_SUCCESS );
}

